<?php
/*
Plugin Name: NextGEN FlashViewer
Plugin URI: http://travel-junkie.com/geeky-stuff/wp-plugin-nextgen-flashviewer/
Description: The famous Adobe Flash Plugins (SimpleViewer, TiltViewer, AutoViewer, PostcardViewer) from <a href="http://www.airtightinteractive.com/">Airtight Interactive</a> for NextGEN Gallery. Initial Plugin by <a href="http://alexrabe.boelinger.com/">Alex Rabe</a>, who did the bulk of the work. Find more information on the original plugin <a href="http://alexrabe.boelinger.com/2008/03/07/simple-nextgen-simpleviewer/">here</a>. Go to <a href="admin.php?page=nggallery-flashviewer">Gallery->FlashViewer</a> to change the options.
Author: Boris Glumpler
Author URI: http://travel-junkie.com/
Version: 0.92

Copyright 2008 by Alex Rabe & Airtight Interactive & Boris Glumpler

This script is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************
****************************************************************************

SimpleViewer/TiltViewer/Autoviewer may be used in any kinds of personal and/or commercial projects. 
Please ensure that the SimpleViewer/TiltViewer/Autoviewer download link in the bottom right corner is clearly visible.
SimpleViewer/TiltViewer may not be redistributed or resold to other companies or third parties. 
Specifically, SimpleViewer/TiltViewer/Autoviewer may not be redistributed as part of a content management system 
or online hosting solution

See more at http://www.airtightinteractive.com/ 
*/ 

//#################################################################
// Stop direct call
if(preg_match('#' . basename(__FILE__) . '#', $_SERVER['PHP_SELF'])) { die(__('You are not allowed to call this page directly.', 'nggflash')); }

//#################################################################
// Let's Go

// define URL
define('NGGFLASHVIEWER_URLPATH', get_option('siteurl').'/wp-content/plugins/' . dirname(plugin_basename(__FILE__)) .'/');
// look for SimpleViewer
define('SIMPLEVIEWER_EXIST', file_exists (dirname (__FILE__).'/flash/viewer.swf'));
// look for TiltViewer
define('TILTVIEWER_EXIST', file_exists (dirname (__FILE__).'/flash/TiltViewer.swf'));
// look for AutoViewer
define('AUTOVIEWER_EXIST', file_exists (dirname (__FILE__).'/flash/autoviewer.swf'));
// look for PostcardViewer
define('PCVIEWER_EXIST', file_exists (dirname (__FILE__).'/flash/pcviewer.swf'));

//Create Text Domain For Translations
function nggflash_textdomain() {
	if (function_exists('load_plugin_textdomain')) {
		load_plugin_textdomain('nggflash','wp-content/plugins/'.dirname(plugin_basename(__FILE__)).'/langs');
	}
}

// Check for NextGEN Gallery
function checkNGGallery() {
	if (!class_exists('nggallery') ) {
		add_action('admin_notices', create_function('', 'echo \'<div id="message" class="error fade"><p><strong>' . __('Sorry, NextGEN FlashViewer works only in combination with NextGEN Gallery.','nggflash') . '</strong></p></div>\';'));
		return;
	}
	add_action('admin_menu','modify_menu_for_nggFlashViewer');
}

function ngg_fv_default_options() {

	/* Settings for SimpleViewer */
    $ngg_fv_options['ngg_sv_max_image_width'] 			= 640;				// Width of your largest image in pixels. Used to determine the best layout for your gallery
    $ngg_fv_options['ngg_sv_max_image_height']			= 480;				// Height of your largest image in pixels. Used to determine the best layout for your gallery.
    $ngg_fv_options['ngg_sv_text_color'] 				= "999999";			// Color of title and caption text (hexidecimal color value e.g 0xff00ff).
	$ngg_fv_options['ngg_sv_preloader_color'] 			= '999999';			// Color of the loading bar (hexidecimal color value e.g 0xff00ff).
    $ngg_fv_options['ngg_sv_frame_color'] 				= "999999";			// Color of image frame, navigation buttons and thumbnail frame (hexidecimal color value e.g 0xff00ff).
    $ngg_fv_options['ngg_sv_frame_width'] 				= 1;				// Width of image frame in pixels.
	$ngg_fv_options['ngg_sv_stage_padding'] 			= 40;				// Distance between image and thumbnails and around gallery edge in pixels.
	$ngg_fv_options['ngg_sv_navPadding'] 				= 40;				// Distance between image and thumbnails (pixels).
    $ngg_fv_options['ngg_sv_thumbnail_columns'] 		= 5;				// Number of thumbnail rows. (To disable thumbnails completely set this value to 0.)
    $ngg_fv_options['ngg_sv_thumbnail_rows'] 			= 2;				// Number of thumbnail columns. (To disable thumbnails completely set this value to 0.)
	$ngg_fv_options['ngg_sv_nav_position'] 				= "top";			// Position of thumbnails relative to image. Can be "top", "bottom","left" or "right".
    $ngg_fv_options['ngg_sv_vAlign'] 					= "center";			// Vertical placment of the image and thumbnails within the SWF. Can be "center", "top" or "bottom". For large format galleries this is best set to "center". For small format galleries setting this to "top" or "bottom" can help get the image flush to the edge of the swf.
    $ngg_fv_options['ngg_sv_hAlign'] 					= "center";			// Horizontal placement of the image and thumbnails within the SWF. Can be "center", "left" or "right". For large format galleries this is best set to "center". For small format galleries setting this to "left" or "right" can help get the image flush to the edge of the swf.
    $ngg_fv_options['ngg_sv_background_image_path'] 	= "";				// Relative or absolute path to a JPG or SWF to load as the gallery background.

	/* Settings for TiltViewer */
    $ngg_fv_options['ngg_tv_max_jpg_size'] 				= 640;				// Set this value to the largest dimension (width or height) of your largest image. TiltViewer uses this value to proportionately scale your images to fit.
    $ngg_fv_options['ngg_tv_use_reload_button'] 		= "false";			// Defines whether to use the circular reload button under the images, or to use next/back arrow buttons for gallery paging.
    $ngg_fv_options['ngg_tv_show_flip_button'] 			= "true";			// Defines whether to display the 'flip' button at the bottom-right of a zoomed in image. Affects all images.
    $ngg_fv_options['ngg_tv_showLinkButton'] 			= "true";			// Defines whether to display the 'go to Flickr page' button on the image flipside. Affects all images.
    $ngg_fv_options['ngg_tv_linkLabel'] 				= "go to Flickr page";			// Text to display as the flipside link button label.
	$ngg_fv_options['ngg_tv_columns'] 					= 5;				// Number of columns of images to display
    $ngg_fv_options['ngg_tv_rows'] 						= 5;				// Number of rows of images to display.
    $ngg_fv_options['ngg_tv_frame_color'] 				= "999999";			// Hexadecimal color value of the image frame.
    $ngg_fv_options['ngg_tv_back_color'] 				= "FFFFFF";			// Hexadecimal color value of the flipside background.
    $ngg_fv_options['ngg_tv_bkgnd_inner_color'] 		= "FFFFFF";			// Hexadecimal color value of the stage background gradient center.
    $ngg_fv_options['ngg_tv_bkgnd_outer_color'] 		= "FFFFFF";			// Hexadecimal color value of the stage background gradient edge.
    $ngg_fv_options['ngg_tv_lang_go_full'] 				= "Go Fullscreen";	// The text displayed for the right-click 'Go Fullscreen' menu option.
    $ngg_fv_options['ngg_tv_lang_exit_full'] 			= "Exit Fullscreen";// The text displayed for the right-click 'Exit Fullscreen' menu option.
    $ngg_fv_options['ngg_tv_lang_about'] 				= "About";			// The text displayed for the right-click 'About' menu option.
	$ngg_fv_options['ngg_tv_user_id']					= "";				// User ID of your Flickr account
	$ngg_fv_options['ngg_tv_tag_mode']					= "any";			// "any" for an OR combination of tags (image can have 1 or more tags to be displayed) "all" for an AND combination (image must have all tags to be displayed) 
	$ngg_fv_options['ngg_tv_showTakenByText']			= "true";			// Defines whether to display the 'taken by X on Y' text on the image flipside.

	/* Additional Settings for TiltViewer (Pro version only)*/
	$ngg_fv_options['have_pro_tv']						= "false";			// Set to true if you have TiltViewer Pro
    $ngg_fv_options['ngg_tv_pro_bkgndTransparent'] 		= "true";			// Defines whether to hide the radial gradient background behind the image grid.
    $ngg_fv_options['ngg_tv_pro_showFullscreenOption'] 	= "true";			// Defines whether to show the 'Go Fullscreen' right-click menu option.
    $ngg_fv_options['ngg_tv_pro_frameWidth'] 			= 10;				// Width of the image frames. To remove frames completely set this to -5.
    $ngg_fv_options['ngg_tv_pro_zoomedInDistance'] 		= 1400;				// Camera distance from image when zoomed in to an image. Increasing this value makes the image smaller.
    $ngg_fv_options['ngg_tv_pro_zoomedOutDistance'] 	= 7500;				// Camera distance from image-grid when zoomed out. Increasing this value makes the image-grid smaller.
    $ngg_fv_options['ngg_tv_pro_fontName'] 				= "Arial";			// Font style used by the flipside text. Note: this font is not embedded in the swf, so the user must have the specified font on their machine to view the font. If they don't have the specified font, they will see the default system font (usually 'sans')
    $ngg_fv_options['ngg_tv_pro_titleFontSize'] 		= 90;				// Font size of flipside title text.
    $ngg_fv_options['ngg_tv_pro_descriptionFontSize'] 	= 32;				// Font size of flipside description text.
    $ngg_fv_options['ngg_tv_pro_navButtonColor'] 		= "CCCCCC";			// Hexadecimal color of the reload or next/back buttons. Default color is white.
    $ngg_fv_options['ngg_tv_pro_flipButtonColor'] 		= "999999";			// Hexadecimal color of the flip buttons. Default color is white.
    $ngg_fv_options['ngg_tv_pro_textColor'] 			= "999999";			// Hexadecimal color value of the flipside text.
    $ngg_fv_options['ngg_tv_pro_linkTextColor'] 		= "523FFE";			// Hexadecimal color value of the flipside link text.
    $ngg_fv_options['ngg_tv_pro_linkBkgndColor'] 		= "FFFFFF";			// Hexadecimal color value of the flipside link text background.
    $ngg_fv_options['ngg_tv_pro_linkFontSize'] 			= 41;				// Font size of flipside link text.
    $ngg_fv_options['ngg_tv_pro_linkTarget'] 			= "_self";			// "_self" specifies the current frame in the current window;"_blank" specifies a new window;"_parent" specifies the parent of the current frame; "_top" specifies the top-level frame in the current window.

	/* Settings for AutoViewer */
    $ngg_fv_options['ngg_av_frame_color'] 				= "999999";			// Hexadecimal color value of the image frame.
    $ngg_fv_options['ngg_av_frame_width'] 				= 1;				// Width of image frame in pixels.
    $ngg_fv_options['ngg_av_image_padding'] 			= 2;				// Padding in pixels.
    $ngg_fv_options['ngg_av_display_time'] 				= 6;				// Time to display image in seconds

	/* Settings for PostcardViewer */
    $ngg_fv_options['ngg_pv_cellDimension'] 			= 800;				// The size of the square 'cell' that contains each image (pixels). Make this at least as big as your biggest image to avoid the images overlapping.
    $ngg_fv_options['ngg_pv_columns'] 					= 4;				// Number of columns of images. Rows are calculated automatically from the number of images in the gallery.
    $ngg_fv_options['ngg_pv_zoomOutPerc'] 				= 15;				// The amout of scale when zoomed out (percentage).
    $ngg_fv_options['ngg_pv_zoomInPerc'] 				= 75;				// The amout of scale when zoomed in (percentage).
    $ngg_fv_options['ngg_pv_frameWidth'] 				= 20;				// Width of image frame (pixels).
 	$ngg_fv_options['ngg_pv_frameColor'] 				= "999999";			// Color of image frame (hexidecimal color value).
    $ngg_fv_options['ngg_pv_captionColor'] 				= "FFFFFF";			// Color of captions (hexidecimal color value).

	/*General Settings*/
    $ngg_fv_options['ngg_fv_effects'] 					= "thickbox";		//Javascript effect for all viewers. Can be "thickbox" or "highslide"
	$ngg_fv_options['ngg_fv_irBackcolor']				= "FFFFFF";			// Background color
    $ngg_fv_options['ngg_fv_enable_right_click_open'] 	= "false";			// Whether to display a 'Open In new Window...' dialog when right-clicking on an image. Can be "true" or "false"
    $ngg_fv_options['ngg_fv_langOpenImage'] 			= "Open Image in New Window";			// The text displayed for the right-click 'Open Image in New Window' menu option.
    $ngg_fv_options['ngg_fv_langAbout'] 				= "About";			// The text displayed for the right-click 'About' menu option.

	update_option('ngg_fv_options', $ngg_fv_options);
}

function SearchForFlashViewer($content) {
	
	global $wpdb;
	
	if ( stristr( $content, '[simpleviewer' )) {	
		$search = "@(?:<p>)*\s*\[simpleviewer\s*=\s*(\w+|^\+)(|,(\d+))(|,(\d+))(|,\*(.*?)\*)\]\s*(?:</p>)*@i";
	
		if	(preg_match_all($search, $content, $matches)) {
			if (is_array($matches)) {
				foreach ($matches[1] as $key =>$match) {
					// check for gallery id
					$galleryID = $wpdb->get_var("SELECT gid FROM $wpdb->nggallery WHERE gid = '$match' ");
					if(!$galleryID) $galleryID = $wpdb->get_var("SELECT gid FROM $wpdb->nggallery WHERE name = '$match' ");
					if($galleryID) {
						$search = $matches[0][$key];
						// get the size if they are set and the link if used
				 		$width  =  $matches[3][$key]; 
						$height =  $matches[5][$key]; 
						$link   =  $matches[7][$key];
						if (SIMPLEVIEWER_EXIST)
							$replace = nggShowSimpleViewer($galleryID,$width,$height,$link);
						else
							$replace ="[".__('viewer.swf not found','nggflash')."]";
						$content= str_replace ($search, $replace, $content);
					}
				}	
			}
		}// end slideshow
	}

	if ( stristr( $content, '[tiltviewer' )) {	
		$search = "@(?:<p>)*\s*\[tiltviewer\s*=\s*(\w+|^\+)(|,(\d+))(|,(\d+))(|,\*(.*?)\*)*(|,\+(.*?)\+)\]\s*(?:</p>)*@i";
	
		if	(preg_match_all($search, $content, $matches)) {
			if (is_array($matches)) {
				foreach ($matches[1] as $key =>$match) {
					// check for gallery id
					if($match == "flickr") 
					$galleryID = "flickr";
					else
					$galleryID = $wpdb->get_var("SELECT gid FROM $wpdb->nggallery WHERE gid = '$match' ");

					if(!$galleryID) $galleryID = $wpdb->get_var("SELECT gid FROM $wpdb->nggallery WHERE name = '$match' ");
					if($galleryID) {
						$search = $matches[0][$key];
						// get the size if they are set and the link if used	
				 		$width  =  $matches[3][$key]; 
						$height =  $matches[5][$key]; 
						$link   =  $matches[7][$key];
						$flickrtags   =  $matches[9][$key];
						
						if (TILTVIEWER_EXIST)
							$replace= nggShowTiltViewer($galleryID,$width,$height,$link,$flickrtags);
						else
							$replace ="[".__('TiltViewer.swf not found','nggflash')."]";
						$content= str_replace ($search, $replace, $content);
					}
				}	
			}
		}// end slideshow
	}

	if ( stristr( $content, '[autoviewer' )) {	
		$search = "@(?:<p>)*\s*\[autoviewer\s*=\s*(\w+|^\+)(|,(\d+))(|,(\d+))(|,\*(.*?)\*)\]\s*(?:</p>)*@i";

		if	(preg_match_all($search, $content, $matches)) {
			if (is_array($matches)) {
				foreach ($matches[1] as $key =>$match) {
					// check for gallery id
					$galleryID = $wpdb->get_var("SELECT gid FROM $wpdb->nggallery WHERE gid = '$match' ");
					if(!$galleryID) $galleryID = $wpdb->get_var("SELECT gid FROM $wpdb->nggallery WHERE name = '$match' ");
					if($galleryID) {
						$search = $matches[0][$key];
						// get the size if they are set and the link if used
				 		$width  =  $matches[3][$key]; 
						$height =  $matches[5][$key]; 
						$link   =  $matches[7][$key];
						if (AUTOVIEWER_EXIST)
							$replace= nggShowAutoViewer($galleryID,$width,$height,$link);
						else
							$replace ="[".__('autoviewer.swf not found','nggflash')."]";
						$content= str_replace ($search, $replace, $content);
					}
				}	
			}
		}// end slideshow
	}
	if ( stristr( $content, '[pcviewer' )) {	
		$search = "@(?:<p>)*\s*\[pcviewer\s*=\s*(\w+|^\+)(|,(\d+))(|,(\d+))(|,\*(.*?)\*)\]\s*(?:</p>)*@i";

		if	(preg_match_all($search, $content, $matches)) {
			if (is_array($matches)) {
				foreach ($matches[1] as $key =>$match) {
					// check for gallery id
					$galleryID = $wpdb->get_var("SELECT gid FROM $wpdb->nggallery WHERE gid = '$match' ");
					if(!$galleryID) $galleryID = $wpdb->get_var("SELECT gid FROM $wpdb->nggallery WHERE name = '$match' ");
					if($galleryID) {
						$search = $matches[0][$key];
						// get the size if they are set and the link if used
				 		$width  =  $matches[3][$key]; 
						$height =  $matches[5][$key]; 
						$link   =  $matches[7][$key];
						if (PCVIEWER_EXIST)
							$replace= nggShowPcViewer($galleryID,$width,$height,$link);
						else
							$replace ="[".__('pcviewer.swf not found','nggflash')."]";
						$content= str_replace ($search, $replace, $content);
					}
				}	
			}
		}// end slideshow
	}

	return $content;
	
}

function nggShowSimpleViewer($galleryID,$irWidth,$irHeight, $link = false) {
	
	global $wpdb;
	$ngg_options = get_option('ngg_options');
	$ngg_fv_options = get_option('ngg_fv_options');

	$obj = 'so' . $galleryID;
	
	if (empty($irWidth) ) $irWidth = $ngg_options['irWidth'];
	if (empty($irHeight)) $irHeight = $ngg_options['irHeight'];

	if (!empty($link)) {
		if ($ngg_fv_options['ngg_fv_effects'] == "thickbox")
				$out = '<a href="#TB_inline?height='.($irHeight+10).'&width='.$irWidth.'&inlineId=ngg_simpleviewer'.$galleryID.'" class="thickbox">'.$link.'</a>';
		if ($ngg_fv_options['ngg_fv_effects'] == "highslide")
				$out =  '<a href="'.NGGFLASHVIEWER_URLPATH.'flash/viewer.swf" onclick="return hs.htmlExpand(this, { swfObject: '.$obj.' } )" class="highslide">'.$link.'</a>';
		if ($ngg_fv_options['ngg_fv_effects'] == "lightview")
				$out =  '<a href="#ngg_simpleviewer'.$galleryID.'" class="lightview" title=":: :: autosize: true">'.$link.'</a>';
	
		$out .= "\n".'<div class="simpleviewer" id="ngg_simpleviewer'.$galleryID.'" style="display: none;">';
	} else {
		$out  = "\n".'<div class="simpleviewer" id="ngg_simpleviewer'.$galleryID.'">';
	}
	
	$out .= '<p>The <a href="http://www.macromedia.com/go/getflashplayer">Flash Player</a> and <a href="http://www.mozilla.com/firefox/">a browser with Javascript support</a> are needed..</p></div>';
    $out .= "\n\t".'<script type="text/javascript" defer="defer">';
	if ($ngg_options['irXHTMLvalid']) $out .= "\n\t".'<!--';
	if ($ngg_options['irXHTMLvalid']) $out .= "\n\t".'//<![CDATA[';
	$out .= "\n\t\t".'var '. $obj .' = new SWFObject("'.NGGFLASHVIEWER_URLPATH.'flash/viewer.swf", "ngg_slideshow'.$galleryID.'", "'.$irWidth.'", "'.$irHeight.'", "7", "#'.$ngg_fv_options['ngg_fv_irBackcolor'].'");';
	$out .= "\n\t\t".$obj.'.addParam("wmode", "opaque");';
	$out .= "\n\t\t".$obj.'.addParam("allowFullScreen", "true");';
	$out .= "\n\t\t".$obj.'.addVariable("preloaderColor", "0x'.$ngg_fv_options['ngg_sv_preloader_color'].'");';
	$out .= "\n\t\t".$obj.'.addVariable("langOpenImage", "'.apply_filters('the_title', $ngg_fv_options['ngg_fv_langOpenImage']).'");';
	$out .= "\n\t\t".$obj.'.addVariable("langAbout", "'.apply_filters('the_title', $ngg_fv_options['ngg_fv_langAbout']).'");';
	$out .= "\n\t\t".$obj.'.addVariable("xmlDataPath", "'.NGGFLASHVIEWER_URLPATH.'nggSimpleViewerXML.php?gid='.$galleryID.'");';
	$out .= "\n\t\t".$obj.'.write("ngg_simpleviewer'.$galleryID.'");';
	if ($ngg_options['irXHTMLvalid']) $out .= "\n\t".'//]]>';
	if ($ngg_options['irXHTMLvalid']) $out .= "\n\t".'-->';
	$out .= "\n\t".'</script>';

	return $out;
}

function nggShowTiltViewer($galleryID,$irWidth,$irHeight, $link = false, $flickrtags = false) {
	
	global $wpdb;
	$ngg_options 	= get_option('ngg_options');
	$ngg_fv_options = get_option('ngg_fv_options');
	if($galleryID == "flickr") {
		$obj = 'fo';
		$flickr = "true";
	 } else {
		$obj = 'so' . $galleryID;
		$flickr = "false";
	}
	$gallerycontent = $wpdb->get_row("SELECT * FROM $wpdb->nggallery WHERE gid = '$galleryID' ");
	
	if (empty($irWidth) ) $irWidth = $ngg_options['irWidth'];
	if (empty($irHeight)) $irHeight = $ngg_options['irHeight'];

	if (!empty($link)) {
		if ($ngg_fv_options['ngg_fv_effects'] == "thickbox")
				$out = '<a href="#TB_inline?height='.($irHeight+10).'&width='.$irWidth.'&inlineId=ngg_tiltviewer'.$galleryID.'" title="'.apply_filters('the_title', $gallerycontent->title).'" class="thickbox">'.$link.'</a>';
		if ($ngg_fv_options['ngg_fv_effects'] == "highslide")
				$out =  '<a href="'.NGGFLASHVIEWER_URLPATH.'flash/TiltViewer.swf" onclick="return hs.htmlExpand(this, { swfObject: '.$obj.' } )" class="highslide">'.$link.'</a>';
		if ($ngg_fv_options['ngg_fv_effects'] == "lightview")
				$out =  '<a href="#ngg_tiltviewer'.$galleryID.'" class="lightview" title="'.apply_filters('the_title', $gallerycontent->title).':: :: autosize: true">'.$link.'</a>';

		$out .= "\n".'<div class="tiltviewer" id="ngg_tiltviewer'.$galleryID.'" style="display: none;">';
	} else {
		$out  = "\n".'<div class="tiltviewer" id="ngg_tiltviewer'.$galleryID.'">';
	}

	$out .= '<p>The <a href="http://www.macromedia.com/go/getflashplayer">Flash Player</a> and <a href="http://www.mozilla.com/firefox/">a browser with Javascript support</a> are needed..</p></div>';
    $out .= "\n\t".'<script type="text/javascript" defer="defer">';
	if ($ngg_options['irXHTMLvalid']) $out .= "\n\t".'<!--';
	if ($ngg_options['irXHTMLvalid']) $out .= "\n\t".'//<![CDATA[';
	$out .= "\n\t\t".'var '. $obj .' = new SWFObject("'.NGGFLASHVIEWER_URLPATH.'flash/TiltViewer.swf", "ngg_slideshow'.$galleryID.'", "'.$irWidth.'", "'.$irHeight.'", "7", "#'.$ngg_fv_options['ngg_fv_irBackcolor'].'");';
	$out .= "\n\t\t".$obj.'.addParam("wmode", "opaque");';
	$out .= "\n\t\t".$obj.'.addParam("allowFullScreen", "true");';
	$out .= "\n\t\t".$obj.'.addVariable("useFlickr", "'.$flickr.'");';
	if ($flickr == "true") {
		$out .= "\n\t\t".$obj.'.addVariable("user_id", "'.$ngg_fv_options['ngg_tv_user_id'].'");';
		$out .= "\n\t\t".$obj.'.addVariable("tags", "'.$flickrtags.'");';	
		$out .= "\n\t\t".$obj.'.addVariable("tag_mode", "'.$ngg_fv_options['ngg_tv_tag_mode'].'");';
		$out .= "\n\t\t".$obj.'.addVariable("showTakenByText", "'.$ngg_fv_options['ngg_tv_showTakenByText'].'");';
		$out .= "\n\t\t".$obj.'.addVariable("showLinkButton", "'.$ngg_fv_options['ngg_tv_showLinkButton'].'");';
		$out .= "\n\t\t".$obj.'.addVariable("linkLabel", "'.apply_filters('the_title', $ngg_fv_options['ngg_tv_linkLabel']).'");';
	}
	if ($flickr == "false") $out .= "\n\t\t".$obj.'.addVariable("maxJPGSize", "'.$ngg_fv_options['ngg_tv_max_jpg_size'].'");';
	$out .= "\n\t\t".$obj.'.addVariable("useReloadButton", "'.$ngg_fv_options['ngg_tv_use_reload_button'].'");';	
	$out .= "\n\t\t".$obj.'.addVariable("showFlipButton", "'.$ngg_fv_options['ngg_tv_show_flip_button'].'");';
	$out .= "\n\t\t".$obj.'.addVariable("columns", "'.$ngg_fv_options['ngg_tv_columns'].'");';
	$out .= "\n\t\t".$obj.'.addVariable("rows", "'.$ngg_fv_options['ngg_tv_rows'].'");';
	$out .= "\n\t\t".$obj.'.addVariable("frameColor", "0x'.$ngg_fv_options['ngg_tv_frame_color'].'");';
	$out .= "\n\t\t".$obj.'.addVariable("backColor", "0x'.$ngg_fv_options['ngg_tv_back_color'].'");';
	$out .= "\n\t\t".$obj.'.addVariable("bkgndInnerColor", "0x'.$ngg_fv_options['ngg_tv_bkgnd_inner_color'].'");';
	$out .= "\n\t\t".$obj.'.addVariable("bkgndOuterColor", "0x'.$ngg_fv_options['ngg_tv_bkgnd_outer_color'].'");';
	$out .= "\n\t\t".$obj.'.addVariable("langGoFull", "'.apply_filters('the_title', $ngg_fv_options['ngg_tv_lang_go_full']).'");';	
	$out .= "\n\t\t".$obj.'.addVariable("langExitFull", "'.apply_filters('the_title', $ngg_fv_options['ngg_tv_lang_exit_full']).'");';	
	$out .= "\n\t\t".$obj.'.addVariable("langAbout", "'.apply_filters('the_title', $ngg_fv_options['ngg_fv_langAbout']).'");';
	if ($ngg_fv_options['have_pro_tv'] == "true") {
		$out .= "\n\t\t".$obj.'.addVariable("bkgndTransparent", "'.$ngg_fv_options['ngg_tv_pro_bkgndTransparent'].'");';
		$out .= "\n\t\t".$obj.'.addVariable("showFullscreenOption", "'.$ngg_fv_options['ngg_tv_pro_showFullscreenOption'].'");';
		$out .= "\n\t\t".$obj.'.addVariable("frameWidth", "'.$ngg_fv_options['ngg_tv_pro_frameWidth'].'");';
		$out .= "\n\t\t".$obj.'.addVariable("zoomedInDistance", "'.$ngg_fv_options['ngg_tv_pro_zoomedInDistance'].'");';
		$out .= "\n\t\t".$obj.'.addVariable("zoomedOutDistance", "'.$ngg_fv_options['ngg_tv_pro_zoomedOutDistance'].'");';
		$out .= "\n\t\t".$obj.'.addVariable("fontName", "'.$ngg_fv_options['ngg_tv_pro_fontName'].'");';
		$out .= "\n\t\t".$obj.'.addVariable("titleFontSize", "'.$ngg_fv_options['ngg_tv_pro_titleFontSize'].'");';
		$out .= "\n\t\t".$obj.'.addVariable("descriptionFontSize", "'.$ngg_fv_options['ngg_tv_pro_descriptionFontSize'].'");';
		$out .= "\n\t\t".$obj.'.addVariable("navButtonColor", "0x'.$ngg_fv_options['ngg_tv_pro_navButtonColor'].'");';
		$out .= "\n\t\t".$obj.'.addVariable("flipButtonColor", "0x'.$ngg_fv_options['ngg_tv_pro_flipButtonColor'].'");';
		$out .= "\n\t\t".$obj.'.addVariable("textColor", "0x'.$ngg_fv_options['ngg_tv_pro_textColor'].'");';
		if ($flickr == "true") {
			$out .= "\n\t\t".$obj.'.addVariable("linkTextColor", "0x'.$ngg_fv_options['ngg_tv_pro_linkTextColor'].'");';
			$out .= "\n\t\t".$obj.'.addVariable("linkBkgndColor", "0x'.$ngg_fv_options['ngg_tv_pro_linkBkgndColor'].'");';
			$out .= "\n\t\t".$obj.'.addVariable("linkFontSize", "'.$ngg_fv_options['ngg_tv_pro_linkFontSize'].'");';
			$out .= "\n\t\t".$obj.'.addVariable("linkTarget", "'.$ngg_fv_options['ngg_tv_pro_linkTarget'].'");';
		}
	}
	if ($flickr == "false") $out .= "\n\t\t".$obj.'.addVariable("xmlURL", "'.NGGFLASHVIEWER_URLPATH.'nggTiltViewerXML.php?gid='.$galleryID.'");';
	$out .= "\n\t\t".$obj.'.write("ngg_tiltviewer'.$galleryID.'");';
	if ($ngg_options['irXHTMLvalid']) $out .= "\n\t".'//]]>';
	if ($ngg_options['irXHTMLvalid']) $out .= "\n\t".'-->';
	$out .= "\n\t".'</script>';

	return $out;
}

function nggShowAutoViewer($galleryID,$irWidth,$irHeight, $link = false) {
	
	global $wpdb;
	$ngg_options 	= get_option('ngg_options');
	$ngg_fv_options = get_option('ngg_fv_options');
	$gallerycontent = $wpdb->get_row("SELECT * FROM $wpdb->nggallery WHERE gid = '$galleryID' ");

	$obj = 'fo' . $galleryID;
	
	if (empty($irWidth) ) $irWidth = $ngg_options['irWidth'];
	if (empty($irHeight)) $irHeight = $ngg_options['irHeight'];

	if (!empty($link)) {
		if ($ngg_fv_options['ngg_fv_effects'] == "thickbox")
				$out = '<a href="#TB_inline?height='.($irHeight+10).'&width='.$irWidth.'&inlineId=ngg_autoviewer'.$galleryID.'" title="'.apply_filters('the_title', $gallerycontent->title).'" class="thickbox">'.$link.'</a>';
		if ($ngg_fv_options['ngg_fv_effects'] == "highslide")
				$out =  '<a href="'.NGGFLASHVIEWER_URLPATH.'flash/autoviewer.swf" onclick="return hs.htmlExpand(this, { swfObject: '.$obj.' } )" class="highslide">'.$link.'</a>';
		if ($ngg_fv_options['ngg_fv_effects'] == "lightview")
				$out =  '<a href="#ngg_autoviewer'.$galleryID.'" class="lightview" title="'.apply_filters('the_title', $gallerycontent->title).':: :: autosize: true">'.$link.'</a>';
		
		$out .= "\n".'<div class="autoviewer" id="ngg_autoviewer'.$galleryID.'" style="display: none;">';
	} else {
		$out  = "\n".'<div class="autoviewer" id="ngg_autoviewer'.$galleryID.'">';
	}

	$out .= '<p>The <a href="http://www.macromedia.com/go/getflashplayer">Flash Player</a> and <a href="http://www.mozilla.com/firefox/">a browser with Javascript support</a> are needed..</p></div>';
    $out .= "\n\t".'<script type="text/javascript" defer="defer">';
	if ($ngg_options['irXHTMLvalid']) $out .= "\n\t".'<!--';
	if ($ngg_options['irXHTMLvalid']) $out .= "\n\t".'//<![CDATA[';
	$out .= "\n\t\t".'var '. $obj .' =  new SWFObject("'.NGGFLASHVIEWER_URLPATH.'flash/autoviewer.swf", "ngg_slideshow'.$galleryID.'", "'.$irWidth.'", "'.$irHeight.'", "8", "#'.$ngg_fv_options['ngg_fv_irBackcolor'].'");';						
	$out .= "\n\t\t".$obj.'.addParam("wmode", "opaque");';
	$out .= "\n\t\t".$obj.'.addVariable("langOpenImage", "'.apply_filters('the_title', $ngg_fv_options['ngg_fv_langOpenImage']).'");';
	$out .= "\n\t\t".$obj.'.addVariable("langAbout", "'.apply_filters('the_title', $ngg_fv_options['ngg_fv_langAbout']).'");';
	$out .= "\n\t\t".$obj.'.addVariable("xmlURL", "'.NGGFLASHVIEWER_URLPATH.'nggAutoViewerXML.php?gid='.$galleryID.'");';					
	$out .= "\n\t\t".$obj.'.write("ngg_autoviewer'.$galleryID.'");';	
	if ($ngg_options['irXHTMLvalid']) $out .= "\n\t".'//]]>';
	if ($ngg_options['irXHTMLvalid']) $out .= "\n\t".'-->';
	$out .= "\n\t".'</script>';

	return $out;
}

function nggShowPcViewer($galleryID,$irWidth,$irHeight, $link = false) {
	
	global $wpdb;
	$ngg_options 	= get_option('ngg_options');
	$ngg_fv_options = get_option('ngg_fv_options');
	$gallerycontent = $wpdb->get_row("SELECT * FROM $wpdb->nggallery WHERE gid = '$galleryID' ");

	$obj = 'fo' . $galleryID;
	
	if (empty($irWidth) ) $irWidth = $ngg_options['irWidth'];
	if (empty($irHeight)) $irHeight = $ngg_options['irHeight'];

	if (!empty($link)) {
		if ($ngg_fv_options['ngg_fv_effects'] == "thickbox")
				$out = '<a href="#TB_inline?height='.($irHeight+10).'&width='.$irWidth.'&inlineId=ngg_pcviewer'.$galleryID.'" title="'.apply_filters('the_title', $gallerycontent->title).'" class="thickbox">'.$link.'</a>';
		if ($ngg_fv_options['ngg_fv_effects'] == "highslide")
				$out =  '<a href="'.NGGFLASHVIEWER_URLPATH.'flash/pcviewer.swf" onclick="return hs.htmlExpand(this, { swfObject: '.$obj.' } )" class="highslide">'.$link.'</a>';
		if ($ngg_fv_options['ngg_fv_effects'] == "lightview")
				$out =  '<a href="#ngg_pcviewer'.$galleryID.'" class="lightview" title="'.apply_filters('the_title', $gallerycontent->title).':: :: autosize: true">'.$link.'</a>';
		
		$out .= "\n".'<div class="pcviewer" id="ngg_pcviewer'.$galleryID.'" style="display: none;">';
	} else {
		$out  = "\n".'<div class="pcviewer" id="ngg_pcviewer'.$galleryID.'">';
	}

	$out .= '<p>The <a href="http://www.macromedia.com/go/getflashplayer">Flash Player</a> and <a href="http://www.mozilla.com/firefox/">a browser with Javascript support</a> are needed..</p></div>';
    $out .= "\n\t".'<script type="text/javascript" defer="defer">';
	if ($ngg_options['irXHTMLvalid']) $out .= "\n\t".'<!--';
	if ($ngg_options['irXHTMLvalid']) $out .= "\n\t".'//<![CDATA[';
	$out .= "\n\t\t".'var '. $obj .' =  new SWFObject("'.NGGFLASHVIEWER_URLPATH.'flash/pcviewer.swf", "ngg_slideshow'.$galleryID.'", "'.$irWidth.'", "'.$irHeight.'", "8", "#'.$ngg_fv_options['ngg_fv_irBackcolor'].'");';						
	$out .= "\n\t\t".$obj.'.addParam("wmode", "opaque");';
	$out .= "\n\t\t".$obj.'.addVariable("langOpenImage", "'.apply_filters('the_title', $ngg_fv_options['ngg_fv_langOpenImage']).'");';
	$out .= "\n\t\t".$obj.'.addVariable("langAbout", "'.apply_filters('the_title', $ngg_fv_options['ngg_fv_langAbout']).'");';
	$out .= "\n\t\t".$obj.'.addVariable("xmlURL", "'.NGGFLASHVIEWER_URLPATH.'nggPostcardViewerXML.php?gid='.$galleryID.'");';					
	$out .= "\n\t\t".$obj.'.write("ngg_pcviewer'.$galleryID.'");';	
	if ($ngg_options['irXHTMLvalid']) $out .= "\n\t".'//]]>';
	if ($ngg_options['irXHTMLvalid']) $out .= "\n\t".'-->';
	$out .= "\n\t".'</script>';

	return $out;
}

// load script files depending on page
function ngg_fv_add_admin_js() {	
		if ($_GET["page"] == "nggallery-flashviewer")
			wp_enqueue_script('tabs', NGGALLERY_URLPATH .'admin/js/jquery.ui.tabs.pack.js', array('jquery'), '2.7.4');
}

// load css files depending on page
function ngg_fv_add_admin_css() {
		if ($_GET["page"] == "nggallery-flashviewer") {
			echo '<link rel="stylesheet" href="'.NGGALLERY_URLPATH.'admin/css/nggadmin.wp25.css" type="text/css" media="screen" />'."\n";
			echo '<link rel="stylesheet" href="'.NGGALLERY_URLPATH.'admin/css/jquery.ui.tabs.css" type="text/css" media="print, projection, screen" />'."\n";
		}
}

function addFlashViewerPage() {
	 // reduce footprint
	 if ($_GET["page"] == "nggallery-flashviewer") {
	 	include_once (dirname (__FILE__). '/nggFlashSettings.php');		// nggallery_admin_options
	 	showFlashViewerPage();
	}
}

function modify_menu_for_nggFlashViewer() {
	// add to NextGEN Menu
	add_submenu_page( NGGFOLDER , __('FlashViewer', 'nggflash'), __('FlashViewer', 'nggflash'), 'NextGEN Change options', 'nggallery-flashviewer', 'addFlashViewerPage');
}

//action and filter calls
add_action('init','nggflash_textdomain');
add_action('plugins_loaded', 'checkNGGallery');
add_action('init', 'ngg_fv_add_admin_js');
add_action('admin_head', 'ngg_fv_add_admin_css');

add_filter('the_content', 'SearchForFlashViewer');
add_filter('the_excerpt', 'SearchForFlashViewer');

register_activation_hook(__FILE__,'ngg_fv_default_options');
?>